﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web;
using TestPaymentGatwayLib.Helper;
using TestPaymentGatwayLib.Interface;
using static TestPaymentGatwayLib.Model.PaymentGatwayModel;

namespace TestPaymentGatwayConsole
{
    public class BankGatway
    {
        IPaymentGatway iPaymentGatway;
        public BankGatway(IPaymentGatway _iPaymentGatway)
        {
            iPaymentGatway = _iPaymentGatway;
        }

        public CustomerInformationModel GetCustomerInfoICICIBank()
        {
            string storeName = "00230338";
            string sharedSecret = "Gw24jnJvVz";
            int Currency = (int)CurrencyCode.INR;
            string ChargeTotal = "1";
            //string domain = HttpContext.Current.Request.Url?.Scheme + "://" + HttpContext.Current.Request.Url?.Host;

            //domain = domain + (HttpContext.Current.Request.Url?.Port == 0 ? "" : ":" + HttpContext.Current.Request.Url?.Port);
            string domain = "http://localhost";
            CustomerInformationModel customerinformationmodel = new CustomerInformationModel()
            {
                StoreName = "33" + storeName,
                sharedSecret = sharedSecret,
                Currency = Currency.ToString(),
                ChargeTotal = ChargeTotal,
                SuccessReturnUrl = string.Concat(domain, "/ICICIBank/SuccessPayment.aspx"),
                FailureReturnUrl = string.Concat(domain, "/ICICIBank/FailurePayment.aspx"),
                Action = ConstantHelper.ICICIPaymentGatewayPurchase
            };
            iPaymentGatway.CustomerInromationPaymentDetail(customerinformationmodel);

            return customerinformationmodel;
        }

        public CustomerInformationModel GetCustomerInfoCCAvenue()
        {
            //string domain = HttpContext.Current.Request.Url?.Scheme + "://" + HttpContext.Current.Request.Url?.Host;

            //domain = domain + (HttpContext.Current.Request.Url?.Port == 0 ? "" : ":" + HttpContext.Current.Request.Url?.Port);
            string domain = "http://localhost";
            CustomerInformationModel customerinformationmodel = new CustomerInformationModel()
            {
                Currency = "INR",
                ChargeTotal = "1",
                GSTPanNumber = "ABC",
                Remarks = "Test Payment",
                CustomerCode = "Test001",
                Invoice = "INV0001",
                Email = "sgigras@gmail.com",
                SuccessReturnUrl = string.Concat(domain, "/CCAvenue/SuccessPayment.aspx"),
                FailureReturnUrl = string.Concat(domain, "/CCAvenue/FailurePayment.aspx"),
                CcAvenueCheckoutUrl = ConstantHelper.CcAvenueCheckoutUrl,
                CcAvenueAccessCode = ConstantHelper.CcAvenueAccessCode
            };
            iPaymentGatway.CustomerInromationPaymentDetail(customerinformationmodel);

            return customerinformationmodel;
        }

        public PaymentFailureModel GetPaymentFailureModel()
        {
            var objFailureModel = new PaymentFailureModel();
            iPaymentGatway.PaymentFailure(objFailureModel);

            return objFailureModel;
        }

        public PaymentSuccesseModel GetPaymentSucessModel()
        {
            var objSuccessModel = new PaymentSuccesseModel();
            iPaymentGatway.PaymentSuccess(objSuccessModel);

            return objSuccessModel;
        }
    }
}
