﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using TestPaymentGatwayLib.Helper;
using TestPaymentGatwayLib.Interface;
using static TestPaymentGatwayLib.Model.PaymentGatwayModel;

namespace TestPaymentGatwayLib.BusinessLogic
{
    public class ICICIHelper : IPaymentGatway
    {
        public void CustomerInromationPaymentDetail(CustomerInformationModel customerinformationmodel)
        {
            string PaymentRefId = UtilityHelper.GetPaymentRefId();

            var TransactionTimestamp = (UtilityHelper.GetIndiaTimeZoneDatetIme()).ToString(@"yyyy\:MM\:dd-HH\:mm\:ss");

            customerinformationmodel.TransactionTimestamp = TransactionTimestamp;
            customerinformationmodel.PaymentRefId = PaymentRefId;

            var stringValue = new StringBuilder(string.Concat(customerinformationmodel.StoreName, TransactionTimestamp, customerinformationmodel.ChargeTotal, customerinformationmodel.Currency, customerinformationmodel.sharedSecret));

            string TransactionReferenceId = UtilityHelper.calculateHashFromString(stringValue.ToString(), "SHA1");

            customerinformationmodel.TransactionReferenceId = TransactionReferenceId;
        }

        public void PaymentFailure(PaymentFailureModel paymentFailureModel)
        {
            UtilityHelper.BindPaymenModel(paymentFailureModel);
        }

        public void PaymentSuccess(PaymentSuccesseModel paymentSuccesseModel)
        {
            UtilityHelper.BindPaymenModel(paymentSuccesseModel);
        }

        public void PaymentRefund(PaymentRefund paymentRefund)
        {

        }
    }
}