﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TestPaymentGatwayLib.Helper
{
    public class CCACrypto
    {
        public string getchecksum(
          string MerchantId,
          string OrderId,
          string Amount,
          string redirectUrl,
          string WorkingKey)
        {
            return this.Adler32(1L, MerchantId + "|" + OrderId + "|" + Amount + "|" + redirectUrl + "|" + WorkingKey);
        }

        public string verifychecksum(
          string MerchantId,
          string OrderId,
          string Amount,
          string AuthDesc,
          string WorkingKey,
          string checksum)
        {
            return string.Compare(this.Adler32(1L, MerchantId + "|" + OrderId + "|" + Amount + "|" + AuthDesc + "|" + WorkingKey), checksum, true) != 0 ? "false" : "true";
        }

        private string Adler32(long adler, string strPattern)
        {
            long num1 = 65521;
            long num2 = this.Andop(adler, (long)ushort.MaxValue);
            long num3 = this.Andop(this.Cdec(this.Rightshift(this.Cbin(adler), 16L)), (long)ushort.MaxValue);
            for (int startIndex = 0; startIndex < strPattern.Length; ++startIndex)
            {
                long num4 = (long)strPattern.Substring(startIndex, 1).ToCharArray()[0];
                num2 = (num2 + num4) % num1;
                num3 = (num3 + num2) % num1;
            }
            return (this.Cdec(this.Leftshift(this.Cbin(num3), 16L)) + num2).ToString();
        }

        private long Power(long num)
        {
            long num1 = 1;
            for (int index = 1; (long)index <= num; ++index)
                num1 *= 2L;
            return num1;
        }

        private long Andop(long op1, long op2)
        {
            string strNum = "";
            string str1 = this.Cbin(op1);
            string str2 = this.Cbin(op2);
            for (int startIndex = 0; startIndex < 32; ++startIndex)
                strNum += (string)(object)(long.Parse(str1.Substring(startIndex, 1)) & long.Parse(str2.Substring(startIndex, 1)));
            return this.Cdec(strNum);
        }

        private string Cbin(long num)
        {
            string str = "";
            do
            {
                str = ((num % 2L).ToString() + str).ToString();
                num = (long)Math.Floor((Decimal)num / new Decimal(2));
            }
            while (num != 0L);
            long num1 = (long)(32 - str.Length);
            for (int index = 1; (long)index <= num1; ++index)
                str = "0" + str;
            return str;
        }

        private string Leftshift(string str, long num)
        {
            long num1 = (long)(32 - str.Length);
            for (int index = 1; (long)index <= num1; ++index)
                str = "0" + str;
            for (int index = 1; (long)index <= num; ++index)
            {
                str += "0";
                str = str.Substring(1, str.Length - 1);
            }
            return str;
        }

        private string Rightshift(string str, long num)
        {
            for (int index = 1; (long)index <= num; ++index)
            {
                str = "0" + str;
                str = str.Substring(0, str.Length - 1);
            }
            return str;
        }

        private long Cdec(string strNum)
        {
            long num = 0;
            for (int startIndex = 0; startIndex < strNum.Length; ++startIndex)
                num += long.Parse(strNum.Substring(startIndex, 1)) * this.Power((long)(strNum.Length - (startIndex + 1)));
            return num;
        }

        public string Encrypt(string strToEncrypt, string Key)
        {
            return new AesCryptUtil(Key).Encrypt(strToEncrypt);
        }

        public string Decrypt(string strToDecrypt, string Key)
        {
            return new AesCryptUtil(Key).Decrypt(strToDecrypt);
        }
    }
}
